/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  org.eclipse.jdt.core.compiler.CharOperation
 *  org.eclipse.jdt.internal.compiler.env.ICompilationUnit
 *  org.eclipse.jdt.internal.compiler.problem.AbortCompilationUnit
 *  org.eclipse.jdt.internal.compiler.util.Util
 */
package org.eclipse.jdt.internal.compiler.batch;

import java.io.File;
import java.io.IOException;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.env.ICompilationUnit;
import org.eclipse.jdt.internal.compiler.problem.AbortCompilationUnit;
import org.eclipse.jdt.internal.compiler.util.Util;

public class CompilationUnit
implements ICompilationUnit {
    public char[] contents;
    public char[] fileName;
    public char[] mainTypeName;
    String encoding;
    public String destinationPath;
    private boolean ignoreOptionalProblems;

    public CompilationUnit(char[] contents, String fileName, String encoding) {
        this(contents, fileName, encoding, null);
    }

    public CompilationUnit(char[] contents, String fileName, String encoding, String destinationPath) {
        this(contents, fileName, encoding, destinationPath, false);
    }

    public CompilationUnit(char[] contents, String fileName, String encoding, String destinationPath, boolean ignoreOptionalProblems) {
        this.contents = contents;
        char[] fileNameCharArray = fileName.toCharArray();
        switch (File.separatorChar) {
            case '/': {
                if (CharOperation.indexOf((char)'\\', (char[])fileNameCharArray) == -1) break;
                CharOperation.replace((char[])fileNameCharArray, (char)'\\', (char)'/');
                break;
            }
            case '\\': {
                if (CharOperation.indexOf((char)'/', (char[])fileNameCharArray) == -1) break;
                CharOperation.replace((char[])fileNameCharArray, (char)'/', (char)'\\');
            }
        }
        this.fileName = fileNameCharArray;
        int start = CharOperation.lastIndexOf((char)File.separatorChar, (char[])fileNameCharArray) + 1;
        int end = CharOperation.lastIndexOf((char)'.', (char[])fileNameCharArray);
        if (end == -1) {
            end = fileNameCharArray.length;
        }
        this.mainTypeName = CharOperation.subarray((char[])fileNameCharArray, (int)start, (int)end);
        this.encoding = encoding;
        this.destinationPath = destinationPath;
        this.ignoreOptionalProblems = ignoreOptionalProblems;
    }

    public char[] getContents() {
        if (this.contents != null) {
            return this.contents;
        }
        try {
            return Util.getFileCharContent((File)new File(new String(this.fileName)), (String)this.encoding);
        }
        catch (IOException e) {
            this.contents = CharOperation.NO_CHAR;
            throw new AbortCompilationUnit(null, e, this.encoding);
        }
    }

    public char[] getFileName() {
        return this.fileName;
    }

    public char[] getMainTypeName() {
        return this.mainTypeName;
    }

    public char[][] getPackageName() {
        return null;
    }

    public boolean ignoreOptionalProblems() {
        return this.ignoreOptionalProblems;
    }

    public String toString() {
        return "CompilationUnit[" + new String(this.fileName) + "]";
    }
}

